/* $Id: pixmap.c,v 1.1.1.1 2005/06/29 11:03:30 kyanh Exp $ */
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#include "../inline_images/toolbar_icons.c"
#include "../inline_images/general_icons.c"

typedef struct {
	const guint id;
	const guint8 *data;
} Tpixmap;

typedef struct {
	const guint id;
	const gchar *stock_id;
} Tstockpixmap;

static Tpixmap tp[] = {
 	{0, pixmap_new}, 
 	{4, pixmap_close}, 
	{13, pixmap_quick_start},
	{15, pixmap_bold},
	{16, pixmap_italic},
	{17, pixmap_underline},
	{25, pixmap_image},
	{27, pixmap_left},
	{28, pixmap_center},
	{29, pixmap_right},
	{30, pixmap_comment},
	{45, pixmap_tablewhiz},
	{46, pixmap_table},
	{73, pixmap_list},
	{101, pixmap_close_small},
 	{104, pixmap_bookmarks},
	{105, pixmap_filetree},
	{106, pixmap_fref},
	{107, pixmap_frinfo},
	{108, pixmap_frdialog},
	{109, pixmap_frsearch},
	{110, pixmap_indent},
	{111, pixmap_unindent},
	{112, pixmap_open_small},
	{150,pixmap_prefseditor},
	{151,pixmap_prefsexternal},
	{152,pixmap_prefsfiles},
	{153,pixmap_prefsfiletypes},
	{154,pixmap_prefshtml},
	{155,pixmap_prefsimages},
	{156,pixmap_prefsinterface},
	{157,pixmap_prefsoutputparser},
	{158,pixmap_prefssyntax},
	{159,pixmap_nothing}
};

static Tstockpixmap tsp[] = {
	{1000, GTK_STOCK_FIND},
	{1001, GTK_STOCK_FIND_AND_REPLACE}
};

GtkWidget *new_pixmap(gint type) {
	GtkWidget *widget;
	gint i;
	if (type < 1000) {
		GdkPixbuf *pixbuf;
		for (i=0;i<(sizeof(tp)/sizeof(Tpixmap));i++) {
			if (tp[i].id == type) {
				break;
			}
		}
		if (i >= sizeof(tp)/sizeof(Tpixmap)) {
			g_print("new_pixmap, requested unknown type %d\n", type);
			i = sizeof(tp)/sizeof(Tpixmap)-1;
		}
		pixbuf = gdk_pixbuf_new_from_inline(-1,tp[i].data,FALSE,NULL);
		widget = gtk_image_new_from_pixbuf(pixbuf);
		g_object_unref(pixbuf);
	} else {
		for (i=0;i<(sizeof(tsp)/sizeof(Tstockpixmap));i++) {
			if (tsp[i].id == type) {
				break;
			}
		}
		if (i >= sizeof(tp)/sizeof(Tpixmap)) {
			g_print("new_pixmap, requested unknown type %d\n", type);
			i = sizeof(tp)/sizeof(Tpixmap)-1;
		}
		widget = gtk_image_new_from_stock(tsp[i].stock_id,GTK_ICON_SIZE_BUTTON);
	}
	return widget;
}

GList *default_icon_list() {
	GList *retlist = NULL;
	retlist = g_list_append(retlist, gdk_pixbuf_new_from_inline(-1,pixmap_winefish_icon1,FALSE,NULL));
	return retlist;
}
